Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1496)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1500)
@@ -5,4 +5,8 @@
 #=,,,,,,,,
 # 3GPP TS 29.061 V15.5.0 (2018-12),,,,,,,,
+# Interworking between the Public Land Mobile Network (PLMN),,,,,,,,
+# supporting packet based services and,,,,,,,,
+# Packet Data Networks (PDN),,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29061-f50.doc,,,,,,,,
 #=,,,,,,,,
@@ -120,5 +124,4 @@
 CN-IP-Multicast-Distribution,921,17.7.24,Enumerated,"M,V",P,,,Y
 MBMS-HC-Indicator,922,17.7.25,Enumerated,"M,V",P,,,Y
-,,,,,,,,
 #=,,,,,,,,
 # 3GPP TS 29.061 Table 20.5a.1: SGmb specific AVPs,,,,,,,,
@@ -144,4 +147,8 @@
 #=,,,,,,,,
 # 3GPP TS 29.128 V15.6.0 (2019-09),,,,,,,,
+# Mobility Management Entity (MME) and Serving GPRS Support,,,,,,,,
+# Node (SGSN) interfaces for interworking with packet data,,,,,,,,
+# networks and applications,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29128-f60.docx,,,,,,,,
 #=,,,,,,,,
@@ -182,4 +189,7 @@
 #=,,,,,,,,
 # 3GPP TS 29.140 V7.0.0 (2007-06),,,,,,,,
+# MM10 interface based on Diameter protocol;,,,,,,,,
+# Stage 3,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29140-700.doc,,,,,,,,
 #=,,,,,,,,
@@ -221,4 +231,10 @@
 #=,,,,,,,,
 # 3GPP TS 29.172 V15.2.0 (2019-12),,,,,,,,
+# Location Services (LCS);,,,,,,,,
+# Evolved Packet Core (EPC) LCS Protocol (ELP) between the,,,,,,,,
+# Gateway Mobile Location Centre (GMLC) and the,,,,,,,,
+# Mobile Management Entity (MME);,,,,,,,,
+# SLg interface,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29172-f20.docx,,,,,,,,
 #=,,,,,,,,
@@ -298,4 +314,7 @@
 #=,,,,,,,,
 # 3GPP TS 29.173 V15.0.0 (2018-06),,,,,,,,
+# Location Services (LCS);,,,,,,,,
+# Diameter-based SLh interface for Control Plane LCS,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29173-f00.doc,,,,,,,,
 #=,,,,,,,,
@@ -321,4 +340,6 @@
 #=,,,,,,,,
 # 3GPP TS 29.210 V6.7.0 (2006-12),,,,,,,,
+# Charging rule provisioning over Gx interface,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29210-670.doc,,,,,,,,
 # ,,,,,,,,
@@ -336,4 +357,6 @@
 #=,,,,,,,,
 # 3GPP TS 29.212 V15.9.0 (2019-12),,,,,,,,
+# Policy and Charging Control (PCC); Reference points,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29212-f90.doc,,,,,,,,
 #=,,,,,,,,
@@ -520,4 +543,6 @@
 #=,,,,,,,,
 # 3GPP TS 29.214 V15.7.0 (2019-09),,,,,,,,
+# Policy and Charging Control over Rx reference point,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29214-f70.doc,,,,,,,,
 #=,,,,,,,,
@@ -597,4 +622,7 @@
 #=,,,,,,,,
 # 3GPP TS 29.229 V15.2.0 (2019-09),,,,,,,,
+# Cx and Dx interfaces based on the Diameter protocol;,,,,,,,,
+# Protocol details,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29229-f20.doc,,,,,,,,
 #=,,,,,,,,
@@ -671,4 +699,8 @@
 #=,,,,,,,,
 # 3GPP TS 29.272 V15.10.0 (2019-12),,,,,,,,
+# Mobility Management Entity (MME),,,,,,,,
+# and Serving GPRS Support Node (SGSN) related interfaces,,,,,,,,
+# based on Diameter protocol,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29272-fa0.docx,,,,,,,,
 #=,,,,,,,,
@@ -894,4 +926,7 @@
 #=,,,,,,,
 # 3GPP TS 29.273 V15.4.0 (2019-09),,,,,,,
+# Evolved Packet System (EPS);,,,,,,,,
+# 3GPP EPS AAA interfaces,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29273-f40.docx,,,,,,,,
 #=,,,,,,,
@@ -992,4 +1027,7 @@
 #=,,,,,,,,
 # 3GPP TS 29.329 V15.2.0 (2019-09),,,,,,,,
+# Sh Interface based on the Diameter protocol;,,,,,,,,
+# Protocol details,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29329-f20.doc,,,,,,,,
 #=,,,,,,,,
@@ -1030,4 +1068,7 @@
 #=,,,,,,,,
 # 3GPP TS 29.336 V15.7.0 (2019-09),,,,,,,,
+# Home Subscriber Server (HSS) diameter interfaces for,,,,,,,,
+# interworking with packet data networks and applications,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29336-f70.docx,,,,,,,,
 #=,,,,,,,,
@@ -1125,5 +1166,9 @@
 #=,,,,,,,,
 # 3GPP TS 29.338 V15.1.0 (2018-12),,,,,,,,
-# From 3GPP 29338-f10.docx,,,,,,,,
+# Diameter based protocols to support,,,,,,,,
+# Short Message Service (SMS) capable,,,,,,,,
+# Mobile Management Entities (MMEs),,,,,,,,
+# ,,,,,,,,
+# From 3GPP 29338-f10.doc,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -1133,5 +1178,5 @@
 #,,,,,,,,
 SM-RP-MTI,3308,5.3.3.2,Enumerated,"M, V",,,,No
-SM-RP-SMEA,3309,5.3.3.3 ,OctetString,"M, V",,,,No
+SM-RP-SMEA,3309,5.3.3.3,OctetString,"M, V",,,,No
 SRR-Flags,3310,5.3.3.4,Unsigned32,"M, V",,,,No
 SM-Delivery-Not-Intended,3311,5.3.3.5,Enumerated,"M, V",,,,No
@@ -1174,4 +1219,8 @@
 #=,,,,,,,,
 # 3GPP TS 29.344 V15.1.0 (2019-09),,,,,,,,
+# Proximity-services (ProSe) Function to Home Subscriber,,,,,,,,
+# Server (HSS) aspects;,,,,,,,,
+# Stage 3,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 29344-f10.doc,,,,,,,,
 #=,,,,,,,,
@@ -1192,4 +1241,7 @@
 #=,,,,,,,,
 # 3GPP TS 32.299 V15.7.0 (2019-06),,,,,,,,
+# Charging management;,,,,,,,,
+# Diameter charging applications,,,,,,,,
+# ,,,,,,,,
 # From 3GPP 32299-f70.doc,,,,,,,,
 #=,,,,,,,,
@@ -1651,4 +1703,6 @@
 #=,,,,,,,,
 # OMA DDS Charging_Data V1.0 20110201-A,,,,,,,,
+# Charging Data,,,,,,,,
+# ,,,,,,,,
 # From OMA OMA-DDS-Charging_Data-V1_0-20110201-A.pdf,,,,,,,,
 #=,,,,,,,,
@@ -1676,4 +1730,7 @@
 #=,,,,,,,,
 # 3GPP2 X.S0057-0 v2.0,,,,,,,,
+# E-UTRAN - eHRPD Connectivity and Interworking:,,,,,,,,
+# Core Network Aspects,,,,,,,,
+# ,,,,,,,,
 # From 3GPP2 X.S0057-0_v2.0_091215.pdf,,,,,,,,
 #=,,,,,,,,