Index: extensions/_sample/hello.cpp
===================================================================
--- extensions/_sample/hello.cpp	(revision 904)
+++ extensions/_sample/hello.cpp	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.l
===================================================================
--- extensions/acl_wl/aw_conf.l	(revision 926)
+++ extensions/acl_wl/aw_conf.l	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.y
===================================================================
--- extensions/acl_wl/aw_conf.y	(revision 926)
+++ extensions/acl_wl/aw_conf.y	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgwx_auth.c
===================================================================
--- extensions/app_radgw/rgwx_auth.c	(revision 924)
+++ extensions/app_radgw/rgwx_auth.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_bench.c
===================================================================
--- extensions/test_app/ta_bench.c	(revision 924)
+++ extensions/test_app/ta_bench.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_cli.c
===================================================================
--- extensions/test_app/ta_cli.c	(revision 924)
+++ extensions/test_app/ta_cli.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameterd/main.c
===================================================================
--- freeDiameterd/main.c	(revision 900)
+++ freeDiameterd/main.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/extension.h
===================================================================
--- include/freeDiameter/extension.h	(revision 904)
+++ include/freeDiameter/extension.h	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/libfdproto.h
===================================================================
--- include/freeDiameter/libfdproto.h	(revision 924)
+++ include/freeDiameter/libfdproto.h	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/cnxctx.c
===================================================================
--- libfdcore/cnxctx.c	(revision 927)
+++ libfdcore/cnxctx.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/core.c
===================================================================
--- libfdcore/core.c	(revision 908)
+++ libfdcore/core.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/dict_base_proto.c
===================================================================
--- libfdcore/dict_base_proto.c	(revision 922)
+++ libfdcore/dict_base_proto.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdcore-internal.h
===================================================================
--- libfdcore/fdcore-internal.h	(revision 909)
+++ libfdcore/fdcore-internal.h	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.l
===================================================================
--- libfdcore/fdd.l	(revision 925)
+++ libfdcore/fdd.l	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.y
===================================================================
--- libfdcore/fdd.y	(revision 918)
+++ libfdcore/fdd.y	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/messages.c
===================================================================
--- libfdcore/messages.c	(revision 924)
+++ libfdcore/messages.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_cnx.c
===================================================================
--- libfdcore/p_cnx.c	(revision 897)
+++ libfdcore/p_cnx.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_out.c
===================================================================
--- libfdcore/p_out.c	(revision 895)
+++ libfdcore/p_out.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_psm.c
===================================================================
--- libfdcore/p_psm.c	(revision 895)
+++ libfdcore/p_psm.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/peers.c
===================================================================
--- libfdcore/peers.c	(revision 917)
+++ libfdcore/peers.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/sctp.c
===================================================================
--- libfdcore/sctp.c	(revision 921)
+++ libfdcore/sctp.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/server.c
===================================================================
--- libfdcore/server.c	(revision 901)
+++ libfdcore/server.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dictionary.c
===================================================================
--- libfdproto/dictionary.c	(revision 910)
+++ libfdproto/dictionary.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/fdproto-internal.h
===================================================================
--- libfdproto/fdproto-internal.h	(revision 924)
+++ libfdproto/fdproto-internal.h	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/log.c
===================================================================
--- libfdproto/log.c	(revision 909)
+++ libfdproto/log.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/messages.c
===================================================================
--- libfdproto/messages.c	(revision 924)
+++ libfdproto/messages.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/msg_log.c
===================================================================
--- libfdproto/msg_log.c	(revision 911)
+++ libfdproto/msg_log.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/sessions.c
===================================================================
--- libfdproto/sessions.c	(revision 924)
+++ libfdproto/sessions.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2012, WIDE Project and NICT								 *
+* Copyright (c) 2013, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testmesg.c
===================================================================
--- tests/testmesg.c	(revision 892)
+++ tests/testmesg.c	(revision 928)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2012, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *