Index: conf/iopmgr.testbed.aaa/dns/dnsmasq.conf
===================================================================
--- conf/iopmgr.testbed.aaa/dns/dnsmasq.conf	(revision 12)
+++ conf/iopmgr.testbed.aaa/dns/dnsmasq.conf	(revision 12)
@@ -0,0 +1,12 @@
+domain-needed
+bogus-priv
+server=/testbed.aaa/192.168.101.1
+local=/iop.testbed.aaa/
+except-interface=eth0
+expand-hosts
+domain=iop.testbed.aaa
+dhcp-range=192.168.110.50,192.168.110.150,255.255.255.0,12h
+
+#dhcp-host=08:00:27:2D:8C:79,cli
+
+
Index: conf/iopmgr.testbed.aaa/dns/hosts
===================================================================
--- conf/iopmgr.testbed.aaa/dns/hosts	(revision 12)
+++ conf/iopmgr.testbed.aaa/dns/hosts	(revision 12)
@@ -0,0 +1,12 @@
+127.0.0.1	localhost
+127.0.1.1	iopmgr.testbed.aaa	iopmgr
+
+# The following lines are desirable for IPv6 capable hosts
+::1     localhost ip6-localhost ip6-loopback
+fe00::0 ip6-localnet
+ff00::0 ip6-mcastprefix
+ff02::1 ip6-allnodes
+ff02::2 ip6-allrouters
+ff02::3 ip6-allhosts
+
+# 192.168.110.10	fdrelay
Index: conf/iopmgr.testbed.aaa/network/interfaces
===================================================================
--- conf/iopmgr.testbed.aaa/network/interfaces	(revision 12)
+++ conf/iopmgr.testbed.aaa/network/interfaces	(revision 12)
@@ -0,0 +1,18 @@
+# This file describes the network interfaces available on your system
+# and how to activate them. For more information, see interfaces(5).
+
+# The loopback network interface
+auto lo
+iface lo inet loopback
+
+# The primary network interface
+auto eth0
+iface eth0 inet dhcp
+
+auto eth1
+iface eth1 inet static
+	address 192.168.110.1
+	netmask	255.255.255.0
+iface eth1 inet6 static
+	address fde4:2c6e:55c4:110::1
+	netmask 64
Index: conf/iopmgr.testbed.aaa/radvd.conf
===================================================================
--- conf/iopmgr.testbed.aaa/radvd.conf	(revision 12)
+++ conf/iopmgr.testbed.aaa/radvd.conf	(revision 12)
@@ -0,0 +1,7 @@
+interface eth1
+{
+   AdvSendAdvert on;
+   prefix fde4:2c6e:55c4:110::/64
+   {
+   };
+};   
Index: nf/mgr.testbeddomain/dns/dnsmasq.d/interopmgr.testbed.aaa
===================================================================
--- conf/mgr.testbeddomain/dns/dnsmasq.d/interopmgr.testbed.aaa	(revision 0)
+++ 	(revision )
@@ -1,1 +1,0 @@
-dhcp-host=08:00:27:87:01:49,interopmgr
Index: conf/mgr.testbeddomain/dns/dnsmasq.d/iopmgr.testbed.aaa
===================================================================
--- conf/mgr.testbeddomain/dns/dnsmasq.d/iopmgr.testbed.aaa	(revision 12)
+++ conf/mgr.testbeddomain/dns/dnsmasq.d/iopmgr.testbed.aaa	(revision 12)
@@ -0,0 +1,1 @@
+dhcp-host=08:00:27:86:9b:42,iopmgr
Index: conf/mgr.testbeddomain/dns/hosts
===================================================================
--- conf/mgr.testbeddomain/dns/hosts	(revision 0)
+++ conf/mgr.testbeddomain/dns/hosts	(revision 12)
@@ -19,5 +19,5 @@
 192.168.101.5	eapmgr
 192.168.101.6	dsmipmgr
-192.168.101.10	interopmgr
+192.168.101.10	iopmgr
 
 # winseven is also managed, but no fixed IP
Index: conf/nas.a.rt.testbed.aaa/freeDiameter/rtd.conf
===================================================================
--- conf/nas.a.rt.testbed.aaa/freeDiameter/rtd.conf	(revision 0)
+++ conf/nas.a.rt.testbed.aaa/freeDiameter/rtd.conf	(revision 12)
@@ -1,2 +1,3 @@
 # Our local proxy is default route for all messages
 * : "proxy.a.rt.testbed.aaa" += DEFAULT;
+* : "proxy.b.rt.testbed.aaa" += DEFAULT;
Index: conf/proxy.a.rt.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/proxy.a.rt.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 0)
+++ conf/proxy.a.rt.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 12)
@@ -50,6 +50,6 @@
 # -------- Test configuration ---------
 
-LoadExtension = "/root/freeDiameter/extensions/dbg_monitor.fdx";
-LoadExtension = "/root/freeDiameter/extensions/dbg_rt.fdx";
+#LoadExtension = "/root/freeDiameter/extensions/dbg_monitor.fdx";
+#LoadExtension = "/root/freeDiameter/extensions/dbg_rt.fdx";
 LoadExtension = "/root/freeDiameter/extensions/acl_wl.fdx"
 		: "/root/conf/freeDiameter/acl_wl.conf";
Index: conf/proxy.b.rt.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/proxy.b.rt.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 0)
+++ conf/proxy.b.rt.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 12)
@@ -50,6 +50,6 @@
 # -------- Test configuration ---------
 
-LoadExtension = "/root/freeDiameter/extensions/dbg_monitor.fdx";
-LoadExtension = "/root/freeDiameter/extensions/dbg_rt.fdx";
+#LoadExtension = "/root/freeDiameter/extensions/dbg_monitor.fdx";
+#LoadExtension = "/root/freeDiameter/extensions/dbg_rt.fdx";
 LoadExtension = "/root/freeDiameter/extensions/acl_wl.fdx"
 		: "/root/conf/freeDiameter/acl_wl.conf";
@@ -57,3 +57,3 @@
 
 ConnectPeer = "proxy.a.rt.testbed.aaa" ;
-
+Realm = "a.rt.testbed.aaa" ;
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/dh.pem
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/dh.pem	(revision 12)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/dh.pem	(revision 12)
@@ -0,0 +1,35 @@
+
+Generator: 05
+
+Prime: 87:96:52:0b:5c:d5:ac:63:f2:46:09:ef
+	c8:f4:30:e7:58:d4:09:c9:f6:90:77:e7
+	7c:bb:04:cc:f8:16:93:90:02:c7:66:74
+	33:96:9d:bc:cb:fc:21:4f:92:b6:57:97
+	2a:be:7c:6f:32:71:18:47:b8:de:50:07
+	5a:a4:17:6d:82:72:31:95:1d:5a:6b:3a
+	b6:aa:9c:ec:78:53:c2:10:59:7f:20:00
+	de:1e:dd:b1:1a:e2:06:11:db:08:56:1e
+	cb:24:f9:6f:b5:86:60:b3:0b:8c:a0:5e
+	85:93:9d:48:e1:3a:40:f6:01:44:21:c9
+	11:aa:2f:0d:78:52:42:32:71:ce:cd:ca
+	b6:11:b9:44:b8:dd:4e:e2:27:89:38:30
+	0e:f8:c9:31:92:b3:32:99:a5:26:f2:59
+	4b:e0:ec:c4:75:c5:53:19:97:f1:c6:00
+	7c:34:39:cf:d4:09:21:ca:64:7e:9c:79
+	97:2d:e9:e5:03:86:3d:30:3e:df:db:4e
+	fd:5c:f0:4e:e8:11:f3:75:a6:34:ac:d0
+	12:b0:3f:df:1e:48:95:27:0b:ec:36:a9
+	b9:6c:eb:fc:cc:b1:36:8d:d9:f3:58:db
+	c8:fa:a9:58:0c:f2:24:6a:89:8e:14:5d
+	25:43:a9:4b:a0:25:8c:50:8f:25:91:46
+	7a:cb:73:cb
+
+
+-----BEGIN DH PARAMETERS-----
+MIIBCAKCAQEAh5ZSC1zVrGPyRgnvyPQw51jUCcn2kHfnfLsEzPgWk5ACx2Z0M5ad
+vMv8IU+StleXKr58bzJxGEe43lAHWqQXbYJyMZUdWms6tqqc7HhTwhBZfyAA3h7d
+sRriBhHbCFYeyyT5b7WGYLMLjKBehZOdSOE6QPYBRCHJEaovDXhSQjJxzs3KthG5
+RLjdTuIniTgwDvjJMZKzMpmlJvJZS+DsxHXFUxmX8cYAfDQ5z9QJIcpkfpx5ly3p
+5QOGPTA+39tO/VzwTugR83WmNKzQErA/3x5IlScL7DapuWzr/MyxNo3Z81jbyPqp
+WAzyJGqJjhRdJUOpS6AljFCPJZFGestzywIBBQ==
+-----END DH PARAMETERS-----
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 10)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 12)
@@ -2,4 +2,5 @@
 TLS_Cred = "/root/ca_data/cert.pem" , "/root/ca_data/privkey.pem";
 TLS_CA = "/root/ca_data/ca.pem";
+TLS_DH_File = "/root/conf/freeDiameter/dh.pem";
 NoRelay;
 
Index: mrb/iop_testbed.sh
===================================================================
--- mrb/iop_testbed.sh	(revision 12)
+++ mrb/iop_testbed.sh	(revision 12)
@@ -0,0 +1,49 @@
+#!/bin/bash 
+
+echo ""
+
+case "$1" in
+  start)
+	# On a besoin de mgr
+	./vm_start.sh "__mgr.testbed.aaa" || {
+		echo "Echec au demarrage de mgr, abandon."
+		exit 1
+	}
+
+	# On a besoin ensuite de rtmgr
+	./vm_start.sh "iop-iopmgr.testbed.aaa" || {
+		echo "Echec au demarrage de iopmgr, abandon."
+		exit 1
+	}
+	
+	# Maintenant on peut demarrer les autres VM en paralelle
+	#./vm_start.sh "eap-supauth.eap.testbed.aaa" &
+	#sleep 3
+	#./vm_start.sh "eap-supauth2.eap.testbed.aaa" &
+	#sleep 3
+	
+	# Done
+	#wait
+	;;
+  pause)
+	# On arrete toutes ces machines en sauvant leur etat
+	./vm_pause.sh "__mgr.testbed.aaa" &
+	./vm_pause.sh "iop-iopmgr.testbed.aaa" &
+	#./vm_pause.sh "eap-supauth.eap.testbed.aaa" &
+	#./vm_pause.sh "eap-opendiam.eap.testbed.aaa" &
+	wait
+	;;
+  stop)
+	# On arrete toutes ces machines en envoyant un shutdown
+	./vm_stop.sh "__mgr.testbed.aaa" &
+	./vm_stop.sh "iop-iopmgr.testbed.aaa" &
+	#./vm_stop.sh "eap-supauth.eap.testbed.aaa" &
+	#./vm_stop.sh "eap-opendiam.eap.testbed.aaa" &
+	wait
+	;;
+  *)
+	echo "Usage: $0 [start|pause|stop]"
+	exit 1
+esac
+
+exit 0