Index: ca/rebuild_tree.sh
===================================================================
--- ca/rebuild_tree.sh	(revision 0)
+++ ca/rebuild_tree.sh	(revision 9)
@@ -7,4 +7,5 @@
 # General-use client and server
 make newcert ca=mgr.testbed.aaa name=client
+make newcert ca=mgr.testbed.aaa name=client2
 make newcert ca=mgr.testbed.aaa name=server
 
Index: conf/backend.eap.testbed.aaa/freeDiameter/CMakeFlags
===================================================================
--- conf/backend.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 7)
+++ conf/backend.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 9)
@@ -2,5 +2,5 @@
 -DBUILD_APP_ACCT:BOOL=ON 
 -DBUILD_TESTING:BOOL=OFF 
--DCMAKE_BUILD_TYPE:STRING=Debug 
+-DCMAKE_BUILD_TYPE:STRING=DebugValgrind
 -DDEFAULT_CONF_PATH:PATH=/root/conf/freeDiameter
 -DBUILD_APP_DIAMEAP:BOOL=ON
Index: conf/backend.eap.testbed.aaa/freeDiameter/app_diameap.sql
===================================================================
--- conf/backend.eap.testbed.aaa/freeDiameter/app_diameap.sql	(revision 8)
+++ conf/backend.eap.testbed.aaa/freeDiameter/app_diameap.sql	(revision 9)
@@ -9,3 +9,4 @@
 
 INSERT INTO users (username, eapmethod) values ( 'client@eap.testbed.aaa', 13 );
+INSERT INTO users (username, eapmethod) values ( 'client2@eap.testbed.aaa', 13 );
 
Index: conf/eapmgr.testbed.aaa/dns/dnsmasq.conf
===================================================================
--- conf/eapmgr.testbed.aaa/dns/dnsmasq.conf	(revision 0)
+++ conf/eapmgr.testbed.aaa/dns/dnsmasq.conf	(revision 9)
@@ -11,5 +11,5 @@
 domain=eap.testbed.aaa
 
-dhcp-range=192.168.105.50,192.168.105.150,255.255.255.0,12h
+dhcp-range=192.168.105.60,192.168.105.150,255.255.255.0,12h
 
 dhcp-host=08:00:27:33:77:82,supauth
@@ -17,4 +17,5 @@
 dhcp-host=08:00:27:F0:A1:70,gw
 dhcp-host=08:00:27:D9:B0:9D,opendiam
+dhcp-host=08:00:27:63:F1:B7,supauth2
 
 #conf-dir=/etc/dnsmasq.d
Index: conf/eapmgr.testbed.aaa/dns/hosts
===================================================================
--- conf/eapmgr.testbed.aaa/dns/hosts	(revision 4)
+++ conf/eapmgr.testbed.aaa/dns/hosts	(revision 9)
@@ -14,4 +14,5 @@
 192.168.105.30	gw
 192.168.105.40	opendiam
+192.168.105.50	supauth2
 fde4:2c6e:55c4:105:a00:27ff:fe33:7782	supauth
 fde4:2c6e:55c4:105:a00:27ff:fef0:a170	gw
Index: conf/gw.eap.testbed.aaa/freeDiameter/CMakeFlags
===================================================================
--- conf/gw.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 5)
+++ conf/gw.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 9)
@@ -1,3 +1,9 @@
 -DBUILD_DBG_MONITOR:BOOL=ON 
--DBUILD_APP_RADGW:BOOL=ON -DBUILD_RGWX_DEBUG:BOOL=ON -DBUILD_RGWX_AUTH:BOOL=ON -DBUILD_RGWX_ACCT:BOOL=ON -DBUILD_RGWX_ECHODROP:BOOL=ON
--DBUILD_TESTING:BOOL=OFF -DCMAKE_BUILD_TYPE:STRING=Debug -DDEFAULT_CONF_PATH:PATH=/root/conf/freeDiameter
+-DBUILD_APP_RADGW:BOOL=ON 
+-DBUILD_RGWX_DEBUG:BOOL=ON 
+-DBUILD_RGWX_AUTH:BOOL=ON 
+-DBUILD_RGWX_ACCT:BOOL=ON 
+-DBUILD_RGWX_ECHODROP:BOOL=ON
+-DBUILD_TESTING:BOOL=OFF 
+-DCMAKE_BUILD_TYPE:STRING=DebugValgrind 
+-DDEFAULT_CONF_PATH:PATH=/root/conf/freeDiameter
Index: conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf
===================================================================
--- conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 0)
+++ conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 9)
@@ -16,4 +16,5 @@
 
 cli = 192.168.105.10 / "radiusecret" ;
+cli = 192.168.105.50 / "radiusecret2" ;
 
 
Index: conf/supauth2.eap.testbed.aaa/ca_name
===================================================================
--- conf/supauth2.eap.testbed.aaa/ca_name	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/ca_name	(revision 9)
@@ -0,0 +1,1 @@
+eap.testbed.aaa
Index: conf/supauth2.eap.testbed.aaa/hostapd/build.config
===================================================================
--- conf/supauth2.eap.testbed.aaa/hostapd/build.config	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/hostapd/build.config	(revision 9)
@@ -0,0 +1,8 @@
+# Build-time configuration for hostapd on supauth: authentication role.
+
+# Driver interface for drivers using the nl80211 kernel interface
+CONFIG_DRIVER_NL80211=y
+
+# Build IPv6 support for RADIUS operations
+CONFIG_IPV6=y
+
Index: conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf	(revision 9)
@@ -0,0 +1,30 @@
+interface=wlan0
+driver=nl80211
+
+logger_stdout=-1
+logger_stdout_level=2
+dump_file=/tmp/hostapd.dump
+
+ctrl_interface=/var/run/hostapd
+
+hw_mode=g
+channel=1
+ssid=mac80211 test2
+
+wpa=2
+wpa_key_mgmt=WPA-EAP
+wpa_pairwise=CCMP
+
+ieee8021x=1
+eapol_version=2
+eap_message=hello
+
+# Configuration for external RADIUS server
+own_ip_addr=192.168.105.50
+nas_identifier=supauth2.eap.testbed.aaa
+auth_server_addr=192.168.105.30
+auth_server_port=1812
+auth_server_shared_secret=radiusecret2
+acct_server_addr=192.168.105.30
+acct_server_port=1813
+acct_server_shared_secret=radiusecret2
Index: conf/supauth2.eap.testbed.aaa/ntp.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/ntp.conf	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/ntp.conf	(revision 9)
@@ -0,0 +1,19 @@
+# /etc/ntp.conf, configuration for ntpd; see ntp.conf(5) for help
+
+driftfile /var/lib/ntp/ntp.drift
+
+statistics loopstats peerstats clockstats
+filegen loopstats file loopstats type day enable
+filegen peerstats file peerstats type day enable
+filegen clockstats file clockstats type day enable
+
+server proxy.testbed.aaa
+
+# By default, exchange time with everybody, but don't allow configuration.
+restrict -4 default kod notrap nomodify nopeer noquery
+restrict -6 default kod notrap nomodify nopeer noquery
+
+# Local users may interrogate the ntp server more closely.
+restrict 127.0.0.1
+restrict ::1
+
Index: conf/supauth2.eap.testbed.aaa/wpasupplicant/build.config
===================================================================
--- conf/supauth2.eap.testbed.aaa/wpasupplicant/build.config	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/wpasupplicant/build.config	(revision 9)
@@ -0,0 +1,26 @@
+# Config file for compilation wpa_supplicant sur supauth.eap.testbed.aaa
+
+# We use the WEXT generic driver with mac80211_hwsim hardware
+CONFIG_DRIVER_WEXT=y
+
+# EAP and EAPoL
+CONFIG_IEEE8021X_EAPOL=y
+CONFIG_EAP_MD5=y
+CONFIG_EAP_MSCHAPV2=y
+CONFIG_EAP_TLS=y
+CONFIG_EAP_PEAP=y
+CONFIG_EAP_TTLS=y
+# CONFIG_EAP_FAST=y
+CONFIG_EAP_GTC=y
+CONFIG_EAP_OTP=y
+CONFIG_EAP_SIM=y
+# ETC...
+CONFIG_EAP_IKEV2=y
+CONFIG_PKCS12=y
+
+CONFIG_EAPOL_TEST=y
+
+CONFIG_CTRL_IFACE=y
+CONFIG_BACKEND=file
+CONFIG_DEBUG_FILE=y
+
Index: conf/supauth2.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf	(revision 9)
@@ -0,0 +1,18 @@
+ctrl_interface=/var/run/wpa_supplicant
+
+network={
+        ssid="mac80211 test2"
+        key_mgmt=WPA-EAP
+        proto=WPA2
+        pairwise=CCMP
+        group=CCMP
+#	eap=MD5
+#	password="himitsu"
+
+	eap=TLS
+	identity="client2@eap.testbed.aaa"
+	ca_cert="/home/aaa/ca/ca_data/mgr.testbed.aaa/public/cacert.pem"
+	client_cert="/home/aaa/ca/ca_data/mgr.testbed.aaa/clients/client2/cert.pem"
+	private_key="/home/aaa/ca/ca_data/mgr.testbed.aaa/clients/client2/privkey.pem"
+}
+
Index: mrb/eap_testbed.sh
===================================================================
--- mrb/eap_testbed.sh	(revision 0)
+++ mrb/eap_testbed.sh	(revision 9)
@@ -20,9 +20,11 @@
 	./vm_start.sh "eap-supauth.eap.testbed.aaa" &
 	sleep 3
+	./vm_start.sh "eap-supauth2.eap.testbed.aaa" &
+	sleep 3
 	./vm_start.sh "eap-gw.eap.testbed.aaa" &
 	sleep 3
 	./vm_start.sh "eap-backend.eap.testbed.aaa" &
-	sleep 3
-	./vm_start.sh "eap-opendiam.eap.testbed.aaa" &
+	#sleep 3
+	#./vm_start.sh "eap-opendiam.eap.testbed.aaa" &
 	
 	# Done
@@ -34,7 +36,8 @@
 	./vm_pause.sh "eap-eapmgr.testbed.aaa" &
 	./vm_pause.sh "eap-supauth.eap.testbed.aaa" &
+	./vm_pause.sh "eap-supauth2.eap.testbed.aaa" &
 	./vm_pause.sh "eap-gw.eap.testbed.aaa" &
 	./vm_pause.sh "eap-backend.eap.testbed.aaa" &
-	./vm_pause.sh "eap-opendiam.eap.testbed.aaa" &
+	#./vm_pause.sh "eap-opendiam.eap.testbed.aaa" &
 	wait
 	;;
@@ -44,7 +47,8 @@
 	./vm_stop.sh "eap-eapmgr.testbed.aaa" &
 	./vm_stop.sh "eap-supauth.eap.testbed.aaa" &
+	./vm_stop.sh "eap-supauth2.eap.testbed.aaa" &
 	./vm_stop.sh "eap-gw.eap.testbed.aaa" &
 	./vm_stop.sh "eap-backend.eap.testbed.aaa" &
-	./vm_stop.sh "eap-opendiam.eap.testbed.aaa" &
+	#./vm_stop.sh "eap-opendiam.eap.testbed.aaa" &
 	wait
 	;;
Index: scripts/freeDiameter-valgrind.sh
===================================================================
--- scripts/freeDiameter-valgrind.sh	(revision 9)
+++ scripts/freeDiameter-valgrind.sh	(revision 9)
@@ -0,0 +1,32 @@
+#!/bin/bash -x
+
+DATE=`date +%Y%m%d-%H%M%S`;
+HOST=`hostname --fqdn`;
+
+ulimit -c 1000000
+rm -f core*
+
+pushd freeDiameter
+make
+popd
+
+case "$1" in
+	helgrind)
+		TOOL="--tool=helgrind"
+		;;
+
+	DRD)
+		TOOL="--tool=drd"
+		;;
+
+	ptrcheck)
+		TOOL="--tool=exp-ptrcheck"
+		;;
+
+
+	*)
+		TOOL=""
+esac
+
+echo fd-$HOST-$DATE.log > /home/aaa/logs/LATEST-$HOST-fd.log
+valgrind $TOOL /root/freeDiameter/freeDiameter/freeDiameterd -dd $* 2>&1 | tee -i /home/aaa/logs/fd-$HOST-$DATE.log
Index: scripts/vboxtools-install.sh
===================================================================
--- scripts/vboxtools-install.sh	(revision 0)
+++ scripts/vboxtools-install.sh	(revision 9)
@@ -2,6 +2,5 @@
 
 # Install the packages
-# aptitude install dkms virtualbox-ose-guest-source virtualbox-ose-guest-utils virtualbox-ose-guest-dkms
-aptitude install dkms virtualbox-ose-guest-source virtualbox-ose-guest-dkms
+aptitude install dkms virtualbox-ose-guest-source virtualbox-ose-guest-dkms virtualbox-ose-guest-utils 
 
 # Done :)